package org.dromara.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.domain.bo.SenClusterNodesBo;
import org.dromara.domain.vo.SenClusterNodesVo;
import org.dromara.domain.SenClusterNodes;
import org.dromara.mapper.SenClusterNodesMapper;
import org.dromara.service.ISenClusterNodesService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 集群配置Service业务层处理
 *
 * @author luogang
 * @date 2024-09-13
 */
@RequiredArgsConstructor
@Service
public class SenClusterNodesServiceImpl implements ISenClusterNodesService {

    private final SenClusterNodesMapper baseMapper;

    /**
     * 查询集群配置
     *
     * @param nodeId 主键
     * @return 集群配置
     */
    @Override
    public SenClusterNodesVo queryById(Long nodeId){
        return baseMapper.selectVoById(nodeId);
    }

    /**
     * 分页查询集群配置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 集群配置分页列表
     */
    @Override
    public TableDataInfo<SenClusterNodesVo> queryPageList(SenClusterNodesBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SenClusterNodes> lqw = buildQueryWrapper(bo);
        Page<SenClusterNodesVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的集群配置列表
     *
     * @param bo 查询条件
     * @return 集群配置列表
     */
    @Override
    public List<SenClusterNodesVo> queryList(SenClusterNodesBo bo) {
        LambdaQueryWrapper<SenClusterNodes> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SenClusterNodes> buildQueryWrapper(SenClusterNodesBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SenClusterNodes> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getAlgorithmProvider()), SenClusterNodes::getAlgorithmProvider, bo.getAlgorithmProvider());
        lqw.eq(StringUtils.isNotBlank(bo.getRunningStatus()), SenClusterNodes::getRunningStatus, bo.getRunningStatus());
        return lqw;
    }

    /**
     * 新增集群配置
     *
     * @param bo 集群配置
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(SenClusterNodesBo bo) {
        SenClusterNodes add = MapstructUtils.convert(bo, SenClusterNodes.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setNodeId(add.getNodeId());
        }
        return flag;
    }

    /**
     * 修改集群配置
     *
     * @param bo 集群配置
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(SenClusterNodesBo bo) {
        SenClusterNodes update = MapstructUtils.convert(bo, SenClusterNodes.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SenClusterNodes entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除集群配置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
